<template>
	<view v-if="detaile">
		<view v-if="detaile&&detaile.contentType!=3">
			<view class="title">{{ detaile.title }}</view>
			<view class="det-sta ddflex">
				<image style="width: 48rpx;height: 48rpx;margin-right: 10rpx;" :src="config.CONFIG_PROJECT_LOGO"></image>
				<view class="sitename" @click="toIndex('')">{{config.CONFIG_PROJECT_TITLE}}</view>
				<view class="time">{{getDateTimeStamp(detaile.time)}}</view>
			</view>
			<view class="video" v-if="detaile.resourceUri&&JSON.parse(detaile.resourceUri).uri">
				<video :src="JSON.parse(detaile.resourceUri).uri" :show-center-play-btn="false" :controls="true" :autoplay="true" id="myVideo" @pause="videoPause" @ended="videoEnded"></video>
				<view class="video-play ddflex" @click="videoPlay()" v-if="detaile.isShowPlayBtn"><image src="../../static/images/play.png"></image></view>
			</view>
			<view class="content">
				<view class="viewMore">
					<mp-html :content="detaile.text" :lazy-load="true" @imgtap="choose"></mp-html>
				</view>
			</view>
			<view style="font-size: 24rpx;color: #999999;line-height: 36rpx;padding: 0 30rpx;">
				部分素材来源：中国人寿寿险app、国寿e店、云助理等。
			</view>
			<view class="operate dflex">
				<view class="zan dflex">
					共{{detaile.browse}}次浏览</view>
				<view class="ddflex">
					<button style="margin-right: 20rpx !important;" class="share ddflex" hover-class="none" @click="userBehavior()"><image :src="detaile.isThumbs?'/static/images/like_h.png':'/static/images/like.png'"></image>{{detaile.thumbsNumber}}</button>
					<view style="margin-left: 30rpx;">
						<button class="share ddflex" hover-class="none" open-type="share"><image src="/static/images/share.png"></image>分享</button>
					</view>
				</view>
			</view>
			<view class="box" v-if="contentList && contentList.length > 0">
				<view class="tit dflex">为您推荐</view>
				<view class="rec">
					<navigator :url="'/topic/content/content?id=' + item.id" hover-class="none" class="li dflex" v-for="(item,index) in contentList" :key="index" v-if="index < 3">
						<view class="flex">
							<view class="rec-tit tovers">{{item.title}}</view>
							<view class="dflex">
								<!-- <view class="author ddflex"><image src="../../static/pages/images/zbgw.png" mode="aspectFill"></image>欧衡</view> -->
								<view class="rec-time">{{item.createDate}}</view>
							</view>
						</view>
						<image :src="item.pic" mode="aspectFill" class="rec-img"></image>
					</navigator>
				</view>
			</view>
		</view>
		<view v-if="detaile&&detaile.contentType==3">
			<web-view :src="webUrl" v-if="webUrl!==''"></web-view>
		</view>
		
	</view>
</template>

<script>
const app = getApp();
const req = require('../../utils/request.js');
const util = require('../../utils/util.js');
import mpHtml from "../../components/mp-html/components/mp-html/mp-html";
export default {
	components: {
		mpHtml,
	},
	data() {
		return {
			detaile: '',
			type: 2, //详情类型：1 普通内容 2 自定义页面内容
			form: {
				page: 1,
				limit: 4,
			},
			contentList: [],
			viewMore: false,
			config: {},
			userInfo:{},
			query:{},
			id:null,
			
			webUrl:'',
			
			tempFilePath:'',
			
			
			isShowUpdate: false, //是否显示更新信息弹窗
			isUpdateInfo: false,//更新用户信息
			isUpdateMobile: false,//绑定手机号
			
			
			enterTime : '',//进入页面时间
			outTime : '',//页面卸载时间
			stayTime : 0//页面停留时间
		};
	},

	onLoad: async function(options) {
		this.query = options
		this.id = options.id;
		await this.getDetail();
		// this.getContentList();
	},
	async onShow(){
		this.getConfig()
	},
	onHide(){
	},
	methods: {
		getConfig() {
			var _this = this;
			return new Promise((res, rej) => {
				req.getRequest(
					'/api/other/config',{},
					data => {
						this.config = data;
						res(data);
					},
					true
				);
			});
		},
		
		monitor() {
			let that = this;
			let system = uni.getSystemInfoSync();
			let query = uni.createSelectorQuery();
			query.select('.viewMore').boundingClientRect(data=>{
				let height = data.height;
				if(height > system.screenHeight) {
					this.viewMore = true
				}
			}).exec();
		},
		viewMores(){
			this.viewMore = true;
		},
		choose: function () {
		  let freshen = false;
		  this.$emit('freshen', {
		    detail: freshen
		  });
		},
		toIndex(){
			// uni.switchTab({
			// 	url: '/pages/index/index'
			// })
		},
		getDateTimeStamp(dateStr){
		 return util.getDateDiff(Date.parse(dateStr.replace(/-/gi,"/")));
		},
		getDetail() {
			let that = this;
			let apiUrl = '/api/content/detail';
			return new Promise((resolve,reject)=>{
				req.getRequest(apiUrl,{ id: that.id },async res => {
					if(res.productCategory){
						res.productCategory = res.productCategory.split(',')
					}
					that.detaile = res;
					that.webUrl = that.detaile.linkUrl?that.detaile.linkUrl:''
					let arr = [];
					if(res.productCategory && res.productCategory.length > 0){
						for (var i = 0; i < res.productCategory.length; i++) {
							await that.getProductList(res.productCategory[i], i).then(res=>{
								arr = arr.concat(res);
								that.productList = arr;
								console.log('相关产品=='+JSON.stringify(arr),arr.length)
							});
						}
					}
					resolve();
				},true);
			})
		},
		getContentList() {
			let form = this.form;
			form.cid = this.detaile.cid;
			if(req.getStorage("shareId")){
				form.shareSaleNo = req.getStorage("shareId")
			}
			req.getRequest('/api/content/list',form,res => {
				this.contentList = res;
				for (var i = 0; i < this.contentList.length; i++) {
					if (this.contentList[i].id == this.id){
						this.contentList.splice(i,1);
					}
				}
			});
		},
	},
	filters: {
		/**
		 * 处理富文本里的图片宽度自适应
		 * 1.去掉img标签里的style、width、height属性
		 * 2.img标签添加style属性：max-width:100%;height:auto
		 * 3.修改所有style里的width属性为max-width:100%
		 * 4.去掉<br/>标签
		 * @param html
		 * @returns {void|string|*}
		 */
		formatRichText(html) {
			//控制小程序中图片大小
			let newContent = html.replace(/<img[^>]*>/gi, function(match, capture) {
				match = match.replace(/style="[^"]+"/gi, '').replace(/style='[^']+'/gi, '');
				match = match.replace(/width="[^"]+"/gi, '').replace(/width='[^']+'/gi, '');
				match = match.replace(/height="[^"]+"/gi, '').replace(/height='[^']+'/gi, '');
				return match;
			});
			newContent = newContent.replace(/style="[^"]+"/gi, function(match, capture) {
				match = match.replace(/width:[^;]+;/gi, 'max-width:100%;').replace(/width:[^;]+;/gi, 'max-width:100%;');
				return match;
			});
			// newContent = newContent.replace(/<br[^>]*\/>/gi, '');
			newContent = newContent.replace(/<br[^>]*\/>/gi, '<p style="margin: 10px 0;"></p>');
			newContent = newContent.replace(/<br[^>]*\>/gi, '<p style="margin: 10px 0;"></p>');
			newContent = newContent.replace(/font-size:[^;]+;?/g,'');
			newContent = newContent.replace(/\<img/gi, '<img style="max-width:100%;height:auto;display:inline-block;margin:12rpx auto;"');
			return newContent;
		}
	}
};
</script>
<style>
@import './content.css';
</style>
